Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.util
Class Base

`java.lang.Object
com.tangosol.util.Base`

Direct Known Subclasses:
  ExternalizableHelper.SimpleXmlBeanClassCache

      public abstract class Base

extends java.lang.Object

Base class for providing standard functionality.

Author:
  cp 2000.08.02

Nested Class Summary
`static class` | `Base.CommonMonitor` A class which acts as CommonMonitor.
`static class` | `Base.LoggingWriter` Inner class for over-riding the destination of log(), out() and err() calls.
`static class` | `Base.StackFrame` A class that provides "stack frame" information from a line of a stack trace.

Field Summary
`static int` | `LOG_ALWAYS` It is expected that items with a log level of 0 will always be logged.
`static int` | `LOG_DEBUG` As of Coherence 3.2, the default logging level is 5, so using the level of 5 will show up in the logs by default as a debug message.
`static int` | `LOG_ERR` Log level 1 indicates an error.
`static int` | `LOG_INFO` Log level 3 indicates information that should likely be logged.
`static int` | `LOG_MAX` The maximum logging level indicator.
`static int` | `LOG_MIN` The minimum logging level indicator.
`static int` | `LOG_QUIET` As of Coherence 3.2, the default logging level is 5, so using a level higher than 5 will be "quiet" by default, meaning that it will not show up in the logs unless the configured logging level is increased.
`static int` | `LOG_WARN` Log level 2 indicates a warning.
`static int` | `POWER_0` Integer constant representing an exponent of zero.
`static int` | `POWER_G` Integer constant representing an exponent of 30.
`static int` | `POWER_K` Integer constant representing an exponent of 10.
`static int` | `POWER_M` Integer constant representing an exponent of 20.
`static int` | `POWER_T` Integer constant representing an exponent of 40.
`static int` | `UNIT_D` Integer constant representing a unit of days.
`static int` | `UNIT_H` Integer constant representing a unit of hours.
`static int` | `UNIT_M` Integer constant representing a unit of minutes.
`static int` | `UNIT_MS` Integer constant representing a unit of milliseconds.
`static int` | `UNIT_NS` Integer constant representing a unit of nanoseconds.
`static int` | `UNIT_S` Integer constant representing a unit of seconds.
`static int` | `UNIT_US` Integer constant representing a unit of microseconds.

Constructor Summary
`Base()`

Method Summary
`static java.lang.RuntimeException` | `azzert()` Definite assertion failure.
`static void` | `azzert(boolean f)` Test an assertion.
`static void` | `azzert(boolean f, java.lang.String s)` Test an assertion, and print the specified message if the assertion fails.
`static void` | `azzertFailed(java.lang.String sMsg)` Throw an assertion exception.
`static java.lang.String` | `breakLines(java.lang.String sText, int nWidth, java.lang.String sIndent)` Breaks the specified string into a multi-line string.
`static java.lang.String` | `breakLines(java.lang.String sText, int nWidth, java.lang.String sIndent, boolean fFirstLine)` Breaks the specified string into a multi-line string.
`static int` | `decimalValue(char ch)` Returns the integer value of a decimal digit.
`static java.lang.String` | `dup(char ch, int cch)` Create a String of the specified length containing the specified character.
`static java.lang.String` | `dup(java.lang.String s, int c)` Create a String which is a duplicate of the specified number of the passed String.
`static java.lang.ClassLoader` | `ensureClassLoader(java.lang.ClassLoader loader)` Obtain a non-null ClassLoader.
`static java.lang.RuntimeException` | `ensureRuntimeException(java.lang.Throwable e)` Convert the passed exception to a RuntimeException if necessary.
`static java.lang.RuntimeException` | `ensureRuntimeException(java.lang.Throwable e, java.lang.String s)` Convert the passed exception to a RuntimeException if necessary.
`static boolean` | `equals(java.lang.Object o1, java.lang.Object o2)` Compare two references for equality.
`static boolean` | `equalsDeep(java.lang.Object o1, java.lang.Object o2)` Deeply compare two references for equality.
`static void` | `err()` Prints a blank line to the trace Writer.
`static void` | `err(java.lang.Class clz)` Prints the passed class information to the trace Writer.
`static void` | `err(java.lang.Object o)` Prints the passed Object to the trace Writer.
`static void` | `err(java.lang.String s)` Prints the passed String value to the trace Writer.
`static void` | `err(java.lang.Throwable e)` Prints the passed exception information to the trace Writer.
`static int` | `escape(char ch, char[] ach, int of)` Format a char to a printable escape if necessary, putting the result into the passed array.
`static java.lang.String` | `formatDateTime(long ldt)` Format a long value into a human readable date/time string.
`static Base.StackFrame` | `getCallerStackFrame()` Get the StackFrame information for the caller of the current method.
`static Base.CommonMonitor` | `getCommonMonitor(int i)` Return the common monitor associated with the specified integer value.
`static Base.CommonMonitor` | `getCommonMonitor(long l)` Return the common monitor associated with the specified long value.
`static Base.CommonMonitor` | `getCommonMonitor(java.lang.Object o)` Return the common monitor associated with the specified object based on its identity hashcode.
`static java.lang.ClassLoader` | `getContextClassLoader()` Try to determine the ClassLoader that supports the current context.
`static java.lang.ClassLoader` | `getContextClassLoader(java.lang.Object o)` Try to determine the ClassLoader that supports the current context.
`static java.lang.String` | `getDeepMessage(java.lang.Throwable t, java.lang.String sDelim)` Extract a throwable's message, and all causal messages.
`static java.io.PrintWriter` | `getErr()` Obtains the current writer used for tracing.
`static long` | `getLastSafeTimeMillis()` Returns the last "safe" time as computed by a previous call to the `getSafeTimeMillis()` method.
`static java.io.PrintWriter` | `getLog()` Obtains the current writer used for logging.
`static int` | `getMaxDecDigits(int n)` Calculate the number of decimal digits needed to display the passed value.
`static int` | `getMaxHexDigits(int n)` Calculate the number of hex digits needed to display the passed value.
`static java.lang.Throwable` | `getOriginalException(java.lang.RuntimeException e)` Unwind the wrapper (runtime) exception to extract the original
`static java.io.PrintWriter` | `getOut()` Obtains the current writer used for printing.
`static java.util.Random` | `getRandom()` Obtain a Random object that can be used to get random values.
`static Binary` | `getRandomBinary(int cbMin, int cbMax)` Generates a random-length Binary within the length bounds provided whose contents are random bytes.
`static java.lang.String` | `getRandomString(int cchMin, int cchMax, boolean fAscii)` Generates a random-length String within the length bounds provided.
`static long` | `getSafeTimeMillis()` Returns a "safe" current time in milliseconds.
`static Base.StackFrame` | `getStackFrame()` Get the StackFrame information for the current method.
`static Base.StackFrame[]` | `getStackFrames()` Iterate the StackFrame information for all callers, going from the inside outwards, and starting with the caller of this method.
`static java.lang.String` | `getStackTrace()` Build a stack trace for the current thread.
`static java.lang.String` | `getStackTrace(java.lang.Throwable e)` Build a stack trace for the passed exception that does not include the exception description itself.
`static ThreadFactory` | `getThreadFactory()` Return the configured thread factory.
`static long` | `getUpTimeMillis()` Return the number of milliseconds which have elapsed since the JVM was started.
`static int` | `hashCode(java.lang.Object o)` Return the hash code for the supplied object or 0 for null.
`static int` | `hexValue(char ch)` Returns the integer value of a hexidecimal digit.
`static java.lang.String` | `indentString(java.lang.String sText, java.lang.String sIndent)` Indent the passed multi-line string.
`static java.lang.String` | `indentString(java.lang.String sText, java.lang.String sIndent, boolean fFirstLine)` Textually indent the passed multi-line string.
`static boolean` | `isDecimal(char ch)` Returns true if the passed character is a decimal digit.
`static boolean` | `isHex(char ch)` Returns true if the passed character is a hexidecimal digit.
`static boolean` | `isLogEcho()` Determine if the log is echoed to the console.
`static boolean` | `isOctal(char ch)` Returns true if the passed character is an octal digit.
`static void` | `log()` Prints a blank line to the log.
`static void` | `log(java.lang.Class clz)` Prints the passed class information to the log.
`static void` | `log(java.lang.Object o)` Prints the passed Object to the log.
`static void` | `log(java.lang.String s)` Prints the passed String value to the log.
`static void` | `log(java.lang.Throwable e)` Prints the passed exception information to the log.
`static java.lang.Integer` | `makeInteger(int n)` Factory method to produce Integer objects with an optimization that uses cached Integer objects for all relatively-low numbers.
`static java.lang.Long` | `makeLong(long n)` Factory method to produce Long objects with an optimization that uses cached Long objects for all relatively-low numbers.
`static java.lang.Thread` | `makeThread(java.lang.ThreadGroup group, java.lang.Runnable runnable, java.lang.String sName)` Create a Thread with the specified group, runnable, and name, using the configured ThreadFactory, as specified by the tangosol.coherence.threadfactory system property.
`static int` | `octalValue(char ch)` Returns the integer value of an octal digit.
`static void` | `out()` Prints a blank line.
`static void` | `out(java.lang.Class clz)` Prints the passed class information.
`static void` | `out(java.lang.Object o)` Prints the passed Object.
`static void` | `out(java.lang.String s)` Prints the passed String value.
`static void` | `out(java.lang.Throwable e)` Prints the passed exception information.
`static long` | `pad(long lMin, long lMultiple)` Return the smallest value that is not less than the first argument and is a multiple of the second argument.
`static long` | `parseBandwidth(java.lang.String s)` Parse the given string representation of a number of bytes per second.
`static long` | `parseBandwidth(java.lang.String s, int nDefaultPower)` Parse the given string representation of a number of bytes per second.
`static java.lang.String[]` | `parseDelimitedString(java.lang.String s, char chDelim)` Parse a character-delimited String into an array of Strings.
`static int` | `parseHex(char ch)` Return the integer value of a hexidecimal digit.
`static byte[]` | `parseHex(java.lang.String s)` Parse the passed String of hexidecimal characters into a binary value.
`static long` | `parseMemorySize(java.lang.String s)` Parse the given string representation of a number of bytes.
`static long` | `parseMemorySize(java.lang.String s, int nDefaultPower)` Parse the given string representation of a number of bytes.
`static long` | `parseTime(java.lang.String s)` Parse the given string representation of a time duration and return its value as a number of milliseconds.
`static long` | `parseTime(java.lang.String s, int nDefaultUnit)` Parse the given string representation of a time duration and return its value as a number of milliseconds.
`static long` | `parseTimeNanos(java.lang.String s)` Parse the given string representation of a time duration and return its value as a number of nanoseconds.
`static long` | `parseTimeNanos(java.lang.String s, int nDefaultUnit)` Parse the given string representation of a time duration and return its value as a number of nanoseconds.
`static java.lang.String` | `printStackTrace(java.lang.Throwable e)` Build a stack trace for the passed exception.
`static java.util.List` | `randomize(java.util.Collection coll)` Randomize the order of the elements within the passed collection.
`static int[]` | `randomize(int[] a)` Randomize the order of the elements within the passed array.
`static java.lang.Object[]` | `randomize(java.lang.Object[] a)` Randomize the order of the elements within the passed array.
`static byte[]` | `read(java.io.DataInput stream)` Read the contents out of the passed stream and return the result as a byte array.
`static byte[]` | `read(java.io.DataInputStream stream)` Read the contents out of the passed stream and return the result as a byte array.
`static byte[]` | `read(java.io.File file)` Read the contents out of the specified file and return the result as a byte array.
`static byte[]` | `read(java.io.InputStream stream)` Read the contents out of the passed stream and return the result as a byte array.
`static int` | `read(java.io.InputStream stream, byte[] ab)` Read the contents out of the passed stream into the passed byte array and return the length read.
`static java.lang.String` | `read(java.io.Reader reader)` Read the contents out of the passed Reader and return the result as a String.
`static byte[]` | `read(java.net.URL url)` Read the contents of the specified URL and return the result as a byte array.
`static void` | `redirectAll(java.io.PrintWriter out)` As much as possible, print absolutely everything to the specified PrintWriter.
`static java.lang.String` | `replace(java.lang.String sText, java.lang.String sFrom, java.lang.String sTo)` Replace all occurences of the specified substring in the specified string.
`static void` | `setErr(java.io.PrintWriter writer)` Sets the current writer used for tracing.
`static void` | `setLog(java.io.PrintWriter writer)` Sets the current writer used for logging.
`static void` | `setLogEcho(boolean fEcho)` Specify whether the log should echo to the console.
`static void` | `setOut(java.io.PrintWriter writer)` Sets the current writer used for printing.
`static java.lang.String` | `toBandwidthString(long cbps)` Format the passed bandwidth (in bytes per second) as a String that can be parsed by `parseBandwidth(java.lang.String)` such that `cb==parseBandwidth(toBandwidthString(cb))` holds true for all legal values of `cbps`.
`static java.lang.String` | `toBandwidthString(long cbps, boolean fExact)` Format the passed bandwidth (in bytes per second) as a String.
`static java.lang.String` | `toCharEscape(char ch)` Format a char to a printable escape if necessary.
`static int` | `toCrc(byte[] ab)` Calculate a CRC32 value from a byte array.
`static int` | `toCrc(byte[] ab, int of, int cb)` Calculate a CRC32 value from a portion of a byte array.
`static int` | `toCrc(byte[] ab, int of, int cb, int nCrc)` Continue to calculate a CRC32 value from a portion of a byte array.
`static java.lang.String` | `toDecString(int n, int cDigits)` Format the passed non-negative integer as a fixed-length decimal string.
`static java.lang.String` | `toDelimitedString(int[] an, java.lang.String sDelim)` Format the content of the passed integer array as a delimited string.
`static java.lang.String` | `toDelimitedString(java.util.Iterator iter, java.lang.String sDelim)` Format the content of the passed Iterator as a delimited string.
`static java.lang.String` | `toDelimitedString(long[] al, java.lang.String sDelim)` Format the content of the passed long array as a delimited string.
`static java.lang.String` | `toDelimitedString(java.lang.Object[] ao, java.lang.String sDelim)` Format the content of the passed Object array as a delimited string.
`static java.lang.String` | `toHex(byte[] ab)` Convert a byte array to the hex sequence of 2 hex digits per byte.
`static java.lang.String` | `toHex(int b)` Convert a byte to the hex sequence of 2 hex digits.
`static java.lang.String` | `toHexDump(byte[] ab, int cBytesPerLine)` Convert a byte array to a hex dump.
`static java.lang.String` | `toHexEscape(byte b)` Convert a byte to a hex sequence of '0' + 'x' + 2 hex digits.
`static java.lang.String` | `toHexEscape(byte[] ab)` Convert a byte array to a hex sequence of '0' + 'x' + 2 hex digits per byte.
`static java.lang.String` | `toHexEscape(byte[] ab, int of, int cb)` Convert a byte array to a hex sequence of '0' + 'x' + 2 hex digits per byte.
`static java.lang.String` | `toHexString(int n, int cDigits)` Format the passed integer as a fixed-length hex string.
`static java.lang.String` | `toMemorySizeString(long cb)` Format the passed memory size (in bytes) as a String that can be parsed by `parseMemorySize(java.lang.String)` such that `cb==parseMemorySize(toMemorySizeString(cb))` holds true for all legal values of `cb`.
`static java.lang.String` | `toMemorySizeString(long cb, boolean fExact)` Format the passed memory size (in bytes) as a String.
`static java.lang.String` | `toQuotedCharEscape(char ch)` Format a char to a printable escape if necessary as it would appear (quoted) in Java source code.
`static java.lang.String` | `toQuotedStringEscape(java.lang.String s)` Format a String as it would appear (quoted) in Java source code, escaping characters as necessary.
`static java.lang.String` | `toSqlString(java.lang.String s)` Escapes the string for SQL.
`static java.lang.String` | `toString(java.lang.Class clz)` Formats Class information for debug output purposes.
`static java.lang.String` | `toString(double dfl, int cMinDigits)` Format a double value as a String.
`static java.lang.String` | `toStringEscape(java.lang.String s)` Format a String escaping characters as necessary.
`static java.lang.String` | `toUnicodeEscape(char ch)` Format a Unicode character to the Unicode escape sequence of '\' + 'u' + 4 hex digis.
`static void` | `trace(boolean fVal)` Display the value of a boolean expression.
`static void` | `trace(byte[] ab)` Display the value of a byte array expression.
`static void` | `trace(char chVal)` Display the value of a char expression.
`static void` | `trace(double dflVal)` Display the value of a double expression.
`static void` | `trace(float flVal)` Display the value of a float expression.
`static void` | `trace(int nVal)` Display the value of an int expression.
`static void` | `trace(long lVal)` Display the value of a long expression.
`static void` | `trace(java.lang.Object oVal)` Display the value of an Object expression.
`static void` | `trace(java.lang.String sVal)` Display the value of a String expression.

Field Detail

### UNIT_NS

    public static final int UNIT_NS

  Integer constant representing a unit of nanoseconds.
  See Also:
    `parseTimeNanos(String, int)`, Constant Field Values

### UNIT_US

    public static final int UNIT_US

  Integer constant representing a unit of microseconds.
  See Also:
    `parseTimeNanos(String, int)`, Constant Field Values

### UNIT_MS

    public static final int UNIT_MS

  Integer constant representing a unit of milliseconds.
  See Also:
    `parseTime(String, int)`, Constant Field Values

### UNIT_S

    public static final int UNIT_S

  Integer constant representing a unit of seconds.
  See Also:
    `parseTime(String, int)`, Constant Field Values

### UNIT_M

    public static final int UNIT_M

  Integer constant representing a unit of minutes.
  See Also:
    `parseTime(String, int)`, Constant Field Values

### UNIT_H

    public static final int UNIT_H

  Integer constant representing a unit of hours.
  See Also:
    `parseTime(String, int)`, Constant Field Values

### UNIT_D

    public static final int UNIT_D

  Integer constant representing a unit of days.
  See Also:
    `parseTime(String, int)`, Constant Field Values

### POWER_0

    public static final int POWER_0

  Integer constant representing an exponent of zero.
  See Also:
    `parseBandwidth(String, int)`, `parseMemorySize(String, int)`, Constant Field Values

### POWER_K

    public static final int POWER_K

  Integer constant representing an exponent of 10.
  See Also:
    `parseBandwidth(String, int)`, `parseMemorySize(String, int)`, Constant Field Values

### POWER_M

    public static final int POWER_M

  Integer constant representing an exponent of 20.
  See Also:
    `parseBandwidth(String, int)`, `parseMemorySize(String, int)`, Constant Field Values

### POWER_G

    public static final int POWER_G

  Integer constant representing an exponent of 30.
  See Also:
    `parseBandwidth(String, int)`, `parseMemorySize(String, int)`, Constant Field Values

### POWER_T

    public static final int POWER_T

  Integer constant representing an exponent of 40.
  See Also:
    `parseBandwidth(String, int)`, `parseMemorySize(String, int)`, Constant Field Values

### LOG_MIN

    public static final int LOG_MIN

  The minimum logging level indicator.
  See Also:
    Constant Field Values

### LOG_MAX

    public static final int LOG_MAX

  The maximum logging level indicator.
  See Also:
    Constant Field Values

### LOG_ALWAYS

    public static final int LOG_ALWAYS

  It is expected that items with a log level of 0 will always be logged.
  See Also:
    Constant Field Values

### LOG_ERR

    public static final int LOG_ERR

  Log level 1 indicates an error.
  See Also:
    Constant Field Values

### LOG_WARN

    public static final int LOG_WARN

  Log level 2 indicates a warning.
  See Also:
    Constant Field Values

### LOG_INFO

    public static final int LOG_INFO

  Log level 3 indicates information that should likely be logged.
  See Also:
    Constant Field Values

### LOG_DEBUG

    public static final int LOG_DEBUG

  As of Coherence 3.2, the default logging level is 5, so using the level of 5 will show up in the logs by default as a debug message.
  See Also:
    Constant Field Values

### LOG_QUIET

    public static final int LOG_QUIET

  As of Coherence 3.2, the default logging level is 5, so using a level higher than 5 will be "quiet" by default, meaning that it will not show up in the logs unless the configured logging level is increased.
  See Also:
    Constant Field Values

Constructor Detail

### Base

    public Base()

Method Detail

### trace

    public static void trace(boolean fVal)

  Display the value of a boolean expression.

### trace

    public static void trace(char chVal)

  Display the value of a char expression.

### trace

    public static void trace(int nVal)

  Display the value of an int expression.

### trace

    public static void trace(long lVal)

  Display the value of a long expression.

### trace

    public static void trace(float flVal)

  Display the value of a float expression.

### trace

    public static void trace(double dflVal)

  Display the value of a double expression.

### trace

    public static void trace(byte[] ab)

  Display the value of a byte array expression.

### trace

    public static void trace(java.lang.String sVal)

  Display the value of a String expression.

### trace

    public static void trace(java.lang.Object oVal)

  Display the value of an Object expression.

### azzert

    public static java.lang.RuntimeException azzert()

  Definite assertion failure.

### azzert

    public static void azzert(boolean f)

  Test an assertion.

### azzert

    public static void azzert(boolean f,
                              java.lang.String s)

  Test an assertion, and print the specified message if the assertion fails.

### azzertFailed

    public static void azzertFailed(java.lang.String sMsg)

  Throw an assertion exception.
  Parameters:
    `sMsg` - the assertion message

### ensureRuntimeException

    public static java.lang.RuntimeException ensureRuntimeException(java.lang.Throwable e)

  Convert the passed exception to a RuntimeException if necessary.
  Parameters:
    `e` - any Throwable object
  Returns:
    a RuntimeException

### ensureRuntimeException

    public static java.lang.RuntimeException ensureRuntimeException(java.lang.Throwable e,
                                                                    java.lang.String s)

  Convert the passed exception to a RuntimeException if necessary.
  Parameters:
    `e` - any Throwable object
    `s` - an additional description
  Returns:
    a RuntimeException

### getOriginalException

    public static java.lang.Throwable getOriginalException(java.lang.RuntimeException e)

  Unwind the wrapper (runtime) exception to extract the original
  Parameters:
    `e` - Runtime exception (wrapper)
  Returns:
    an original wrapped exception

### out

    public static void out()

  Prints a blank line.

### out

    public static void out(java.lang.Object o)

  Prints the passed Object.
  Parameters:
    `o` - the Object to print.

### out

    public static void out(java.lang.String s)

  Prints the passed String value.
  Parameters:
    `s` - the String to print.

### out

    public static void out(java.lang.Class clz)

  Prints the passed class information.
  Parameters:
    `clz` - the class object to print.

### out

    public static void out(java.lang.Throwable e)

  Prints the passed exception information.
  Parameters:
    `e` - the Throwable object to print.

### err

    public static void err()

  Prints a blank line to the trace Writer.

### err

    public static void err(java.lang.Object o)

  Prints the passed Object to the trace Writer.
  Parameters:
    `o` - the Object to print.

### err

    public static void err(java.lang.String s)

  Prints the passed String value to the trace Writer.
  Parameters:
    `s` - the String to print.

### err

    public static void err(java.lang.Class clz)

  Prints the passed class information to the trace Writer.
  Parameters:
    `clz` - the class object to print.

### err

    public static void err(java.lang.Throwable e)

  Prints the passed exception information to the trace Writer.
  Parameters:
    `e` - the Throwable object to print.

### log

    public static void log()

  Prints a blank line to the log.

### log

    public static void log(java.lang.Object o)

  Prints the passed Object to the log.
  Parameters:
    `o` - the Object to print.

### log

    public static void log(java.lang.String s)

  Prints the passed String value to the log.
  Parameters:
    `s` - the String to print.

### log

    public static void log(java.lang.Class clz)

  Prints the passed class information to the log.
  Parameters:
    `clz` - the class object to print.

### log

    public static void log(java.lang.Throwable e)

  Prints the passed exception information to the log.
  Parameters:
    `e` - the Throwable object to print.

### ensureClassLoader

    public static java.lang.ClassLoader ensureClassLoader(java.lang.ClassLoader loader)

  Obtain a non-null ClassLoader.
  Parameters:
    `loader` - a ClassLoader (may be null)
  Returns:
    the passed ClassLoader (if not null), or the ContextClassLoader

### getContextClassLoader

    public static java.lang.ClassLoader getContextClassLoader()

  Try to determine the ClassLoader that supports the current context.
  Returns:
    a ClassLoader to use for the current context

### getContextClassLoader

    public static java.lang.ClassLoader getContextClassLoader(java.lang.Object o)

  Try to determine the ClassLoader that supports the current context.
  Parameters:
    `o` - the calling object, or any object out of the application that is requesting the class loader
  Returns:
    a ClassLoader to use for the current context

### getCallerStackFrame

    public static Base.StackFrame getCallerStackFrame()

  Get the StackFrame information for the caller of the current method.
  Returns:
    the StackFrame information for the caller of the current method

### getStackFrame

    public static Base.StackFrame getStackFrame()

  Get the StackFrame information for the current method.
  Returns:
    the StackFrame information for the current method

### getStackFrames

    public static Base.StackFrame[] getStackFrames()

  Iterate the StackFrame information for all callers, going from the inside outwards, and starting with the caller of this method.
  Returns:
    an Iterator of StackFrames

### getStackTrace

    public static java.lang.String getStackTrace()

  Build a stack trace for the current thread.
  Returns:
    a String containing a printable stack trace

### getStackTrace

    public static java.lang.String getStackTrace(java.lang.Throwable e)

  Build a stack trace for the passed exception that does not include the exception description itself.
  Parameters:
    `e` - a Throwable object that contains stack trace information
  Returns:
    a String containing a printable stack trace

### getDeepMessage

    public static java.lang.String getDeepMessage(java.lang.Throwable t,
                                                  java.lang.String sDelim)

  Extract a throwable's message, and all causal messages.
  Parameters:
    `t` - the throwable
    `sDelim` - the delimiter to include between messages
  Returns:
    the concatenated messages

### printStackTrace

    public static java.lang.String printStackTrace(java.lang.Throwable e)

  Build a stack trace for the passed exception.
  Parameters:
    `e` - a Throwable object that contains stack trace information
  Returns:
    a String containing a printable stack trace

### makeThread

    public static java.lang.Thread makeThread(java.lang.ThreadGroup group,
                                              java.lang.Runnable runnable,
                                              java.lang.String sName)

  Create a Thread with the specified group, runnable, and name, using the configured ThreadFactory, as specified by the tangosol.coherence.threadfactory system property.
  Parameters:
    `group` - (optional) the thread's thread group
    `runnable` - (optional) the thread's runnable
    `sName` - (optional) the thread's name
  Returns:
    a new thread using the specified parameters

### getThreadFactory

    public static ThreadFactory getThreadFactory()

  Return the configured thread factory.
  Returns:
    the configured thread factory, or null if none has been configured.

### getCommonMonitor

    public static Base.CommonMonitor getCommonMonitor(int i)

  Return the common monitor associated with the specified integer value. Common monitors allow for a low-cost means to reduce contention by spreading synchronization over a large number of monitors. An example useage would be to produce an "atomic array" without utilizing the Java 1.5 java.util.concurrent features. For instance to atomically change an element within an array which is being simultaneously updated by multiple threads:

       synchronized (getCommonMonitor(System.identityHashCode(aoShared) + i))
           {
           oOld = aoShared[i];
           aoShared[i] = oNew;
           }

  With this approach many threads may concurrently access various array elements without having to synchronize on the array itself, and contend with each other. The use of common monitors also avoids the overhead of allocating a unique monitor per index. This example additionally makes use of the array's identity hash code to avoid frequent collisions against other atomic arrays for the same indices. As they are shared, these monitors will apply to any number of unrelated entities, and as such certain precautions must be employed when using them.
  - The holder of a common monitor MUST not synchronize on any other common monitor. Failure to adhere to this precaution will result in a deadlock.
  - Notifications on a common monitor MUST use notifyAll() rather then notify(), as there may be unrelated threads waiting for notification on the same monitor which could consume a single notification. Thus the only way to ensure that the desired thread does receive notification is to notify all threads waiting on the monitor.
  - Threads waiting for a notification must protect themselves against spurious style wakeups. While this is a general, though often overlooked part of the normal use of notification, with common monitors it is far more likely that a thread will be notified due to an unrelated event.
  - A thread which is holding synchronization on a common monitor should avoid blocking operations as this could block unrelated threads which happen to be utilizing the same common monitor.
  The ideal number of common monitors in a JVM is one per concurrently executing thread. As this number is generally unknown the actual number of monitors is pre-sized based on a multiple of the number of processors available to the JVM. The value may also be manually specified via the `tangosol.coherence.commonmonitors` system property.
  Parameters:
    `i` - the common monitor identifier
  Returns:
    the assocaited monitor

### getCommonMonitor

    public static Base.CommonMonitor getCommonMonitor(long l)

  Return the common monitor associated with the specified long value.
  Parameters:
    `l` - the common monitor identifier
  Returns:
    the associated monitor
  See Also:
    `getCommonMonitor(int)`

### getCommonMonitor

    public static Base.CommonMonitor getCommonMonitor(java.lang.Object o)

  Return the common monitor associated with the specified object based on its identity hashcode.
  Parameters:
    `o` - the object to obtain a common monitor for
  Returns:
    the associated monitor
  See Also:
    `getCommonMonitor(int)`

### toString

    public static java.lang.String toString(java.lang.Class clz)

  Formats Class information for debug output purposes.
  Parameters:
    `clz` - the Class to print information for
  Returns:
    a String describing the Class in detail

### isDecimal

    public static boolean isDecimal(char ch)

  Returns true if the passed character is a decimal digit.
  Parameters:
    `ch` - The character to check

### decimalValue

    public static int decimalValue(char ch)

  Returns the integer value of a decimal digit.
  Parameters:
    `ch` - The character to convert

### getMaxDecDigits

    public static int getMaxDecDigits(int n)

  Calculate the number of decimal digits needed to display the passed value.
  Parameters:
    `n` - the value
  Returns:
    the number of decimal digits needed to display the value

### toDecString

    public static java.lang.String toDecString(int n,
                                               int cDigits)

  Format the passed non-negative integer as a fixed-length decimal string.
  Parameters:
    `n` - the value
    `cDigits` - the length of the resulting decimal string
  Returns:
    the decimal value formated to the specified length string

### pad

    public static long pad(long lMin,
                           long lMultiple)

  Return the smallest value that is not less than the first argument and is a multiple of the second argument. Effectively rounds the first argument up to a multiple of the second.
  Parameters:
    `lMin` - the smallest value to return
    `lMultiple` - the return value will be a multiple of this argument
  Returns:
    the smallest multiple of the second argument that is not less than the first

### isOctal

    public static boolean isOctal(char ch)

  Returns true if the passed character is an octal digit.
  Parameters:
    `ch` - The character to check

### octalValue

    public static int octalValue(char ch)

  Returns the integer value of an octal digit.
  Parameters:
    `ch` - The character to convert

### isHex

    public static boolean isHex(char ch)

  Returns true if the passed character is a hexidecimal digit.
  Parameters:
    `ch` - The character to check

### hexValue

    public static int hexValue(char ch)

  Returns the integer value of a hexidecimal digit.
  Parameters:
    `ch` - The character to convert

### getMaxHexDigits

    public static int getMaxHexDigits(int n)

  Calculate the number of hex digits needed to display the passed value.
  Parameters:
    `n` - the value
  Returns:
    the number of hex digits needed to display the value

### toHexString

    public static java.lang.String toHexString(int n,
                                               int cDigits)

  Format the passed integer as a fixed-length hex string.
  Parameters:
    `n` - the value
    `cDigits` - the length of the resulting hex string
  Returns:
    the hex value formated to the specified length string

### toHex

    public static java.lang.String toHex(int b)

  Convert a byte to the hex sequence of 2 hex digits.
  Parameters:
    `b` - the byte
  Returns:
    the hex sequence

### toHex

    public static java.lang.String toHex(byte[] ab)

  Convert a byte array to the hex sequence of 2 hex digits per byte. This is a replacement for Text.toString(char[]).
  Parameters:
    `ab` - the byte array
  Returns:
    the hex sequence

### toHexEscape

    public static java.lang.String toHexEscape(byte b)

  Convert a byte to a hex sequence of '0' + 'x' + 2 hex digits.
  Parameters:
    `b` - the byte
  Returns:
    the hex sequence

### toHexEscape

    public static java.lang.String toHexEscape(byte[] ab)

  Convert a byte array to a hex sequence of '0' + 'x' + 2 hex digits per byte.
  Parameters:
    `ab` - the byte array
  Returns:
    the hex sequence

### toHexEscape

    public static java.lang.String toHexEscape(byte[] ab,
                                               int of,
                                               int cb)

  Convert a byte array to a hex sequence of '0' + 'x' + 2 hex digits per byte.
  Parameters:
    `ab` - the byte array
    `of` - the offset into array
    `cb` - the number of bytes to convert
  Returns:
    the hex sequence

### toHexDump

    public static java.lang.String toHexDump(byte[] ab,
                                             int cBytesPerLine)

  Convert a byte array to a hex dump. This is a replacement for Text.toString(byte[] ab, int cBytesPerLine).
  Parameters:
    `ab` - the byte array to format as a hex string
    `cBytesPerLine` - the number of bytes to display on a line
  Returns:
    a multi-line hex dump

### parseHex

    public static byte[] parseHex(java.lang.String s)

  Parse the passed String of hexidecimal characters into a binary value. This implementation allows the passed String to be prefixed with "0x".
  Parameters:
    `s` - the hex String to evaluate
  Returns:
    the byte array value of the passed hex String

### parseHex

    public static int parseHex(char ch)

  Return the integer value of a hexidecimal digit.
  Parameters:
    `ch` - the hex character to evaluate
  Returns:
    the integer value of the passed hex character

### toString

    public static java.lang.String toString(double dfl,
                                            int cMinDigits)

  Format a double value as a String.
  Parameters:
    `dfl` - a double value
    `cMinDigits` - the minimum number of digits of precision to display
  Returns:
    the double value formatted as a String

### toUnicodeEscape

    public static java.lang.String toUnicodeEscape(char ch)

  Format a Unicode character to the Unicode escape sequence of '\' + 'u' + 4 hex digis.
  Parameters:
    `ch` - the character
  Returns:
    the Unicode escape sequence

### toCharEscape

    public static java.lang.String toCharEscape(char ch)

  Format a char to a printable escape if necessary.
  Parameters:
    `ch` - the char
  Returns:
    a printable String representing the passed char

### toQuotedCharEscape

    public static java.lang.String toQuotedCharEscape(char ch)

  Format a char to a printable escape if necessary as it would appear (quoted) in Java source code. This is a replacement for Text.printableChar().
  Parameters:
    `ch` - the character
  Returns:
    a printable String in single quotes representing the passed char

### toStringEscape

    public static java.lang.String toStringEscape(java.lang.String s)

  Format a String escaping characters as necessary.
  Parameters:
    `s` - the String
  Returns:
    a printable String representing the passed String

### toQuotedStringEscape

    public static java.lang.String toQuotedStringEscape(java.lang.String s)

  Format a String as it would appear (quoted) in Java source code, escaping characters as necessary. This is a replacement for Text.printableString().
  Parameters:
    `s` - the String
  Returns:
    a printable String in double quotes representing the passed String

### escape

    public static int escape(char ch,
                             char[] ach,
                             int of)

  Format a char to a printable escape if necessary, putting the result into the passed array. The array must be large enough to accept six characters.
  Parameters:
    `ch` - the character to format
    `ach` - the array of characters to format into
    `of` - the offset in the array to format at
  Returns:
    the number of characters used to format the char

### toSqlString

    public static java.lang.String toSqlString(java.lang.String s)

  Escapes the string for SQL.
  Returns:
    the string quoted for SQL and escaped as necessary

### indentString

    public static java.lang.String indentString(java.lang.String sText,
                                                java.lang.String sIndent)

  Indent the passed multi-line string.
  Parameters:
    `sText` - the string to indent
    `sIndent` - a string used to indent each line
  Returns:
    the string, indented

### indentString

    public static java.lang.String indentString(java.lang.String sText,
                                                java.lang.String sIndent,
                                                boolean fFirstLine)

  Textually indent the passed multi-line string.
  Parameters:
    `sText` - the string to indent
    `sIndent` - a string used to indent each line
    `fFirstLine` - true indents all lines; false indents all but the first
  Returns:
    the string, indented

### breakLines

    public static java.lang.String breakLines(java.lang.String sText,
                                              int nWidth,
                                              java.lang.String sIndent)

  Breaks the specified string into a multi-line string.
  Parameters:
    `sText` - the string to break
    `nWidth` - the max width of resulting lines (including the indent)
    `sIndent` - a string used to indent each line
  Returns:
    the string, broken and indented

### breakLines

    public static java.lang.String breakLines(java.lang.String sText,
                                              int nWidth,
                                              java.lang.String sIndent,
                                              boolean fFirstLine)

  Breaks the specified string into a multi-line string.
  Parameters:
    `sText` - the string to break
    `nWidth` - the max width of resulting lines (including the indent)
    `sIndent` - a string used to indent each line
    `fFirstLine` - if true indents all lines; otherwise indents all but the first
  Returns:
    the string, broken and indented

### dup

    public static java.lang.String dup(char ch,
                                       int cch)

  Create a String of the specified length containing the specified character.
  Parameters:
    `ch` - the character to fill the String with
    `cch` - the length of the String
  Returns:
    a String containing the character <ch> repeated <cch> times

### dup

    public static java.lang.String dup(java.lang.String s,
                                       int c)

  Create a String which is a duplicate of the specified number of the passed String.
  Parameters:
    `s` - the String to fill the new String with
    `c` - the number of duplicates to put into the new String
  Returns:
    a String containing the String `s` repeated `c` times

### replace

    public static java.lang.String replace(java.lang.String sText,
                                           java.lang.String sFrom,
                                           java.lang.String sTo)

  Replace all occurences of the specified substring in the specified string.
  Parameters:
    `sText` - string to change
    `sFrom` - pattern to change from
    `sTo` - pattern to change to
  Returns:
    modified string

### parseDelimitedString

    public static java.lang.String[] parseDelimitedString(java.lang.String s,
                                                          char chDelim)

  Parse a character-delimited String into an array of Strings.
  Parameters:
    `s` - character-delimited String to parse
    `chDelim` - character delimiter
  Returns:
    an array of String objects parsed from the passed String

### toDelimitedString

    public static java.lang.String toDelimitedString(int[] an,
                                                     java.lang.String sDelim)

  Format the content of the passed integer array as a delimited string.
  Parameters:
    `an` - the array
    `sDelim` - the delimiter
  Returns:
    the formated string

### toDelimitedString

    public static java.lang.String toDelimitedString(long[] al,
                                                     java.lang.String sDelim)

  Format the content of the passed long array as a delimited string.
  Parameters:
    `al` - the array
    `sDelim` - the delimiter
  Returns:
    the formated string

### toDelimitedString

    public static java.lang.String toDelimitedString(java.lang.Object[] ao,
                                                     java.lang.String sDelim)

  Format the content of the passed Object array as a delimited string.
  Parameters:
    `ao` - the array
    `sDelim` - the delimiter
  Returns:
    the formated string

### toDelimitedString

    public static java.lang.String toDelimitedString(java.util.Iterator iter,
                                                     java.lang.String sDelim)

  Format the content of the passed Iterator as a delimited string.
  Parameters:
    `iter` - the Iterator
    `sDelim` - the delimiter
  Returns:
    the formated string

### parseBandwidth

    public static long parseBandwidth(java.lang.String s)

  Parse the given string representation of a number of bytes per second. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[[B|b][P|p][S|s]]?`

  where the first non-digit (from left to right) indicates the factor with which the preceeding decimal value should be multiplied:

  - `K` or `k` (kilo, 210)
  - `M` or `m` (mega, 220)
  - `G` or `g` (giga, 230)
  - `T` or `t` (tera, 240)

  If the string value does not contain a factor, a factor of one is assumed.

  The optional last three characters indicate the unit of measure, `[b][P|p][S|s]` in the case of bits per second and `[B][P|p][S|s]` in the case of bytes per second. If the string value does not contain a unit, a unit of bits per second is assumed.

  Parameters:
    `s` - a string with the format: `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[[B|b][P|p][S|s]]?`
  Returns:
    the number of bytes per second represented by the given string

### parseBandwidth

    public static long parseBandwidth(java.lang.String s,
                                      int nDefaultPower)

  Parse the given string representation of a number of bytes per second. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[[B|b][P|p][S|s]]?`

  where the first non-digit (from left to right) indicates the factor with which the preceeding decimal value should be multiplied:

  - `K` or `k` (kilo, 210)
  - `M` or `m` (mega, 220)
  - `G` or `g` (giga, 230)
  - `T` or `t` (tera, 240)

  If the string value does not contain an explict or implicit factor, a factor calculated by raising 2 to the given default power is used. The default power can be one of:

  - `POWER_0`
  - `POWER_K`
  - `POWER_M`
  - `POWER_G`
  - `POWER_T`

  The optional last three characters indicate the unit of measure, `[b][P|p][S|s]` in the case of bits per second and `[B][P|p][S|s]` in the case of bytes per second. If the string value does not contain a unit, a unit of bits per second is assumed.

  Parameters:
    `s` - a string with the format: `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[[B|b][P|p][S|s]]?`
    `nDefaultPower` - the exponent used to calculate the factor used in the conversion if one is not implied by the given string
  Returns:
    the number of bytes per second represented by the given string

### toBandwidthString

    public static java.lang.String toBandwidthString(long cbps)

  Format the passed bandwidth (in bytes per second) as a String that can be parsed by `parseBandwidth(java.lang.String)` such that `cb==parseBandwidth(toBandwidthString(cb))` holds true for all legal values of `cbps`.
  Parameters:
    `cbps` - the number of bytes per second
  Returns:
    a String representation of the given bandwidth

### toBandwidthString

    public static java.lang.String toBandwidthString(long cbps,
                                                     boolean fExact)

  Format the passed bandwidth (in bytes per second) as a String. This method will possibly round the memory size for purposes of producing a more-easily read String value unless the `fExact` parameters is passed as true; if `fExact` is true, then `cb==parseBandwidth(toBandwidthString(cb, true))` holds true for all legal values of `cbps`.
  Parameters:
    `cbps` - the number of bytes per second
    `fExact` - true if the String representation must be exact, or false if it can be an approximation
  Returns:
    a String representation of the given bandwidth

### parseMemorySize

    public static long parseMemorySize(java.lang.String s)

  Parse the given string representation of a number of bytes. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[B|b]?`

  where the first non-digit (from left to right) indicates the factor with which the preceeding decimal value should be multiplied:

  - `K` or `k` (kilo, 210)
  - `M` or `m` (mega, 220)
  - `G` or `g` (giga, 230)
  - `T` or `t` (tera, 240)

  If the string value does not contain a factor, a factor of one is assumed.

  The optional last character `B` or `b` indicates a unit of bytes.

  Parameters:
    `s` - a string with the format `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[B|b]?`
  Returns:
    the number of bytes represented by the given string

### parseMemorySize

    public static long parseMemorySize(java.lang.String s,
                                       int nDefaultPower)

  Parse the given string representation of a number of bytes. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[B|b]?`

  where the first non-digit (from left to right) indicates the factor with which the preceeding decimal value should be multiplied:

  - `K` or `k` (kilo, 210)
  - `M` or `m` (mega, 220)
  - `G` or `g` (giga, 230)
  - `T` or `t` (tera, 240)

  If the string value does not contain an explict or implicit factor, a factor calculated by raising 2 to the given default power is used. The default power can be one of:

  - `POWER_0`
  - `POWER_K`
  - `POWER_M`
  - `POWER_G`
  - `POWER_T`

  The optional last character `B` or `b` indicates a unit of bytes.

  Parameters:
    `s` - a string with the format `[\d]+[[.][\d]+]?[K|k|M|m|G|g|T|t]?[B|b]?`
    `nDefaultPower` - the exponent used to calculate the factor used in the conversion if one is not implied by the given string
  Returns:
    the number of bytes represented by the given string

### toMemorySizeString

    public static java.lang.String toMemorySizeString(long cb)

  Format the passed memory size (in bytes) as a String that can be parsed by `parseMemorySize(java.lang.String)` such that `cb==parseMemorySize(toMemorySizeString(cb))` holds true for all legal values of `cb`.
  Parameters:
    `cb` - the number of bytes of memory
  Returns:
    a String representation of the given memory size

### toMemorySizeString

    public static java.lang.String toMemorySizeString(long cb,
                                                      boolean fExact)

  Format the passed memory size (in bytes) as a String. This method will possibly round the memory size for purposes of producing a more-easily read String value unless the `fExact` parameters is passed as true; if `fExact` is true, then `cb==parseMemorySize(toMemorySizeString(cb, true))` holds true for all legal values of `cb`.
  Parameters:
    `cb` - the number of bytes of memory
    `fExact` - true if the String representation must be exact, or false if it can be an approximation
  Returns:
    a String representation of the given memory size

### parseTime

    public static long parseTime(java.lang.String s)

  Parse the given string representation of a time duration and return its value as a number of milliseconds. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`

  where the first non-digits (from left to right) indicate the unit of time duration:

  - `NS` or `ns` (nanoseconds)
  - `US` or `us` (microseconds)
  - `MS` or `ms` (milliseconds)
  - `S` or `s` (seconds)
  - `M` or `m` (minutes)
  - `H` or `h` (hours)
  - `D` or `d` (days)

  If the string value does not contain a unit, a unit of milliseconds is assumed.

  Parameters:
    `s` - a string with the format `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`
  Returns:
    the number of milliseconds represented by the given string rounded down to the nearest millisecond
  See Also:
    `parseTimeNanos(String)`

### parseTime

    public static long parseTime(java.lang.String s,
                                 int nDefaultUnit)

  Parse the given string representation of a time duration and return its value as a number of milliseconds. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`

  where the first non-digits (from left to right) indicate the unit of time duration:

  - `NS` or `ns` (nanoseconds)
  - `US` or `us` (microseconds)
  - `MS` or `ms` (milliseconds)
  - `S` or `s` (seconds)
  - `M` or `m` (minutes)
  - `H` or `h` (hours)
  - `D` or `d` (days)

  If the string value does not contain a unit, the specified default unit is assumed. The default unit can be one of:

  - `UNIT_NS`
  - `UNIT_US`
  - `UNIT_MS`
  - `UNIT_S`
  - `UNIT_M`
  - `UNIT_H`
  - `UNIT_D`
  Parameters:
    `s` - a string with the format `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`
    `nDefaultUnit` - the unit to use in the conversion to milliseconds if one is not specified in the supplied string
  Returns:
    the number of milliseconds represented by the given string rounded down to the nearest millisecond
  See Also:
    `parseTimeNanos(String, int)`

### parseTimeNanos

    public static long parseTimeNanos(java.lang.String s)

  Parse the given string representation of a time duration and return its value as a number of nanoseconds. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`

  where the first non-digits (from left to right) indicate the unit of time duration:

  - `NS` or `ns` (nanoseconds)
  - `US` or `us` (microseconds)
  - `MS` or `ms` (milliseconds)
  - `S` or `s` (seconds)
  - `M` or `m` (minutes)
  - `H` or `h` (hours)
  - `D` or `d` (days)

  If the string value does not contain a unit, a unit of nanoseconds is assumed.

  Parameters:
    `s` - a string with the format `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`
  Returns:
    the number of nanoseconds represented by the given string rounded down to the nearest nanosecond

### parseTimeNanos

    public static long parseTimeNanos(java.lang.String s,
                                      int nDefaultUnit)

  Parse the given string representation of a time duration and return its value as a number of nanoseconds. The supplied string must be in the format:

  `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`

  where the first non-digits (from left to right) indicate the unit of time duration:

  - `NS` or `ns` (nanoseconds)
  - `US` or `us` (microseconds)
  - `MS` or `ms` (milliseconds)
  - `S` or `s` (seconds)
  - `M` or `m` (minutes)
  - `H` or `h` (hours)
  - `D` or `d` (days)

  If the string value does not contain a unit, the specified default unit is assumed. The default unit can be one of:

  - `UNIT_NS`
  - `UNIT_US`
  - `UNIT_MS`
  - `UNIT_S`
  - `UNIT_M`
  - `UNIT_H`
  - `UNIT_D`
  Parameters:
    `s` - a string with the format `[\d]+[[.][\d]+]?[NS|ns|US|us|MS|ms|S|s|M|m|H|h|D|d]?`
    `nDefaultUnit` - the unit to use in the conversion to nanoseconds if one is not specified in the supplied string
  Returns:
    the number of nanoseconds represented by the given string rounded down to the nearest nanosecond

### formatDateTime

    public static java.lang.String formatDateTime(long ldt)

  Format a long value into a human readable date/time string.
  Parameters:
    `ldt` - a Java long containing a date/time value
  Returns:
    a human readable date/time string

### hashCode

    public static int hashCode(java.lang.Object o)

  Return the hash code for the supplied object or 0 for null.
  Parameters:
    `o` - the object to hash
  Returns:
    the hash code for the supplied object

### equals

    public static boolean equals(java.lang.Object o1,
                                 java.lang.Object o2)

  Compare two references for equality.
  Parameters:
    `o1` -
    `o2` -
  Returns:
    true if equal, false otherwise

### equalsDeep

    public static boolean equalsDeep(java.lang.Object o1,
                                     java.lang.Object o2)

  Deeply compare two references for equality. This dives down into arrays, including nested arrays.
  Parameters:
    `o1` -
    `o2` -
  Returns:
    true if deeply equal, false otherwise

### toCrc

    public static int toCrc(byte[] ab)

  Calculate a CRC32 value from a byte array.
  Parameters:
    `ab` - an array of bytes
  Returns:
    the 32-bit CRC value

### toCrc

    public static int toCrc(byte[] ab,
                            int of,
                            int cb)

  Calculate a CRC32 value from a portion of a byte array.
  Parameters:
    `ab` - an array of bytes
    `of` - the offset into the array
    `cb` - the number of bytes to evaluate
  Returns:
    the 32-bit CRC value

### toCrc

    public static int toCrc(byte[] ab,
                            int of,
                            int cb,
                            int nCrc)

  Continue to calculate a CRC32 value from a portion of a byte array.
  Parameters:
    `ab` - an array of bytes
    `of` - the offset into the array
    `cb` - the number of bytes to evaluate
    `nCrc` - the previous CRC value
  Returns:
    the 32-bit CRC value

### getUpTimeMillis

    public static long getUpTimeMillis()

  Return the number of milliseconds which have elapsed since the JVM was started.
  Returns:
    the number of milliseconds which have elapsed since the JVM was started

### getSafeTimeMillis

    public static long getSafeTimeMillis()

  Returns a "safe" current time in milliseconds.
  Returns:
    the difference, measured in milliseconds, between the corrected current time and midnight, January 1, 1970 UTC.
  See Also:
    `SafeClock`

### getLastSafeTimeMillis

    public static long getLastSafeTimeMillis()

  Returns the last "safe" time as computed by a previous call to the `getSafeTimeMillis()` method.
  Returns:
    the last "safe" time in milliseconds
  See Also:
    `SafeClock`

### makeInteger

    public static java.lang.Integer makeInteger(int n)

  Factory method to produce Integer objects with an optimization that uses cached Integer objects for all relatively-low numbers.
  Parameters:
    `n` - an int
  Returns:
    an Integer whose value is the passed int
  Since:
    Coherence 3.2

### makeLong

    public static java.lang.Long makeLong(long n)

  Factory method to produce Long objects with an optimization that uses cached Long objects for all relatively-low numbers.
  Parameters:
    `n` - a long
  Returns:
    a Long whose value is the passed long
  Since:
    Coherence 3.2

### getRandom

    public static java.util.Random getRandom()

  Obtain a Random object that can be used to get random values.
  Returns:
    a random number generator
  Since:
    Coherence 3.2

### randomize

    public static java.util.List randomize(java.util.Collection coll)

  Randomize the order of the elements within the passed collection.
  Parameters:
    `coll` - the Collection to randomize; the passed Collection is not altered
  Returns:
    a new and immutable List whose contents are identical to those of the passed collection except for the order in which they appear
  Since:
    Coherence 3.2

### randomize

    public static java.lang.Object[] randomize(java.lang.Object[] a)

  Randomize the order of the elements within the passed array.
  Parameters:
    `a` - an array of objects to randomize
  Returns:
    the array that was passed in, and with its contents unchanged except for the order in which they appear
  Since:
    Coherence 3.2

### randomize

    public static int[] randomize(int[] a)

  Randomize the order of the elements within the passed array.
  Parameters:
    `a` - an array of `int` values to randomize
  Returns:
    the array that was passed in, and with its contents unchanged except for the order in which they appear
  Since:
    Coherence 3.2

### getRandomBinary

    public static Binary getRandomBinary(int cbMin,
                                         int cbMax)

  Generates a random-length Binary within the length bounds provided whose contents are random bytes.
  Parameters:
    `cbMin` - the minimum number of bytes in the resulting Binary
    `cbMax` - the maximum number of bytes in the resulting Binary
  Returns:
    a randomly generated Binary object
  Since:
    Coherence 3.2

### getRandomString

    public static java.lang.String getRandomString(int cchMin,
                                                   int cchMax,
                                                   boolean fAscii)

  Generates a random-length String within the length bounds provided. If the ASCII option is indicated, the characters will be in the range [32-127], otherwise the characters will be in the range [0x0000-0xFFFF].
  Parameters:
    `cchMin` - the minimum length of the resulting String
    `cchMax` - the maximum length of the resulting String
    `fAscii` - true if the resulting String should contain only ASCII values
  Returns:
    a randomly generated String object
  Since:
    Coherence 3.2

### getOut

    public static java.io.PrintWriter getOut()

  Obtains the current writer used for printing.
  Returns:
    the current writer used for printing; never null

### setOut

    public static void setOut(java.io.PrintWriter writer)

  Sets the current writer used for printing.
  Parameters:
    `writer` - the java.io.PrintWriter instance to use for printing; may be null

### getErr

    public static java.io.PrintWriter getErr()

  Obtains the current writer used for tracing.
  Returns:
    the current writer used for tracing; never null

### setErr

    public static void setErr(java.io.PrintWriter writer)

  Sets the current writer used for tracing.
  Parameters:
    `writer` - the java.io.PrintWriter instance to use for tracing; may be null

### getLog

    public static java.io.PrintWriter getLog()

  Obtains the current writer used for logging.
  Returns:
    the current writer used for logging; never null

### setLog

    public static void setLog(java.io.PrintWriter writer)

  Sets the current writer used for logging.
  Parameters:
    `writer` - the java.io.PrintWriter instance to use for logging; may be null

### isLogEcho

    public static boolean isLogEcho()

  Determine if the log is echoed to the console.
  Returns:
    true if the log is echoed to the console

### setLogEcho

    public static void setLogEcho(boolean fEcho)

  Specify whether the log should echo to the console.
  Parameters:
    `fEcho` - true if the log should echo to the console

### redirectAll

    public static void redirectAll(java.io.PrintWriter out)

  As much as possible, print absolutely everything to the specified PrintWriter.
  Parameters:
    `out` - the PrintWriter to write everything to

### read

    public static int read(java.io.InputStream stream,
                           byte[] ab)
                    throws java.io.IOException

  Read the contents out of the passed stream into the passed byte array and return the length read. This method will read up to the number of bytes that can fit into the passed array.
  Parameters:
    `stream` - a java.io.InputStream object to read from
    `ab` - a byte array to read into
  Returns:
    the number of bytes read from the InputStream and stored into the passed byte array
  Throws:
    `java.io.IOException`

### read

    public static byte[] read(java.io.InputStream stream)
                       throws java.io.IOException

  Read the contents out of the passed stream and return the result as a byte array.
  Parameters:
    `stream` - a java.io.InputStream object to read from
  Returns:
    a byte array containing the contents of the passed InputStream
  Throws:
    `java.io.IOException`

### read

    public static byte[] read(java.io.DataInput stream)
                       throws java.io.IOException

  Read the contents out of the passed stream and return the result as a byte array.
  Parameters:
    `stream` - a java.io.DataInput object to read from
  Returns:
    a byte array containing the contents of the passed stream
  Throws:
    `java.io.IOException`

### read

    public static byte[] read(java.io.DataInputStream stream)
                       throws java.io.IOException

  Read the contents out of the passed stream and return the result as a byte array.
  Parameters:
    `stream` - a java.io.DataInputStream object to read from
  Returns:
    a byte array containing the contents of the passed InputStream
  Throws:
    `java.io.IOException`

### read

    public static java.lang.String read(java.io.Reader reader)
                                 throws java.io.IOException

  Read the contents out of the passed Reader and return the result as a String.
  Parameters:
    `reader` - a java.io.Reader object to read from
  Returns:
    a String containing the contents of the passed Reader
  Throws:
    `java.io.IOException`

### read

    public static byte[] read(java.io.File file)
                       throws java.io.IOException

  Read the contents out of the specified file and return the result as a byte array.
  Parameters:
    `file` - the java.io.File object to read the contents of
  Returns:
    the contents of the specified File as a byte array
  Throws:
    `java.io.IOException`

### read

    public static byte[] read(java.net.URL url)
                       throws java.io.IOException

  Read the contents of the specified URL and return the result as a byte array.
  Parameters:
    `url` - the java.net.URL object to read the contents of
  Returns:
    the contents of the specified URL as a byte array
  Throws:
    `java.io.IOException`

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.